﻿using System;
using System.IO;
using System.Threading.Tasks;

namespace TelegramParsingLibrary
{
    public class Logger
    {
        public static event EventHandler<string> NewError;
        public static string FileName { get; set; }
        private static object _locker = new object();

#pragma warning disable 
        public async static void WriteError(Exception ex, bool sendMessage = true)
        {
            var rows = ex.Message.Split("\n\r".ToCharArray(), StringSplitOptions.RemoveEmptyEntries);

            Task.Run(() => writeError(ex));
            if (sendMessage)
            {
                Task.Run(() => NewError?.Invoke(null, ex.Message));
            }

#pragma warning restore
        }

        private static void writeError(Exception ex)
        {
            try
            {
                if (ex is AggregateException)
                {
                    if (((AggregateException)ex).InnerExceptions != null && ((AggregateException)ex).InnerExceptions.Count > 0)
                    {
                        foreach (var e in ((AggregateException)ex).InnerExceptions)
                        {
                            writeError(e);
                        }
                    }
                    else if (((AggregateException)ex).InnerException != null)
                    {
                        writeError(((AggregateException)ex).InnerException);
                    }
                }
                else
                {
                    lock (_locker)
                    {
                        File.AppendAllText(Path.Combine(Environment.CurrentDirectory, "Logs", FileName),
                            DateTime.Now.ToString("yyyyMMdd HHmmss") + ex.Message + "\n" + ex.StackTrace + "\n");

                        if (ex.InnerException != null)
                        {
                            File.AppendAllText(Path.Combine(Environment.CurrentDirectory, "Logs", FileName),
                                "Inner Exception:\n" + ex.InnerException.Message + "\n");
                        }
                    }
                }
            }
            catch { }
        }

        public static void Write(string v)
        {
            try
            {
                lock (_locker)
                {
                    File.AppendAllText(Path.Combine(Environment.CurrentDirectory, "Logs", FileName),
                        DateTime.Now.ToString("yyyyMMdd HHmmss") + ":\n" + v + "\n");
                }
            }
            catch { }
        }
    }
}